<template>
  <navbar></navbar>
  <h1 class="text-center mt-5 text-4xl font-bold">Subir Entrega</h1>
  <h1 class="text-center mt-8 text-3xl font-semibold">
    Tarea {{ response.tareaId }}
  </h1>
  <div class="text-sm breadcrumbs ml-12 mt-10">
  <ul>
    <li>
      <a @click="
          $router.push({
            path: elegirAsignaturaURL  
          })
        ">
        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" class="w-4 h-4 mr-2 stroke-current"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"></path></svg>
        Elegir Asignatura
      </a>
    </li> 
    <li>
      <a  @click="
          $router.push({
            path: listaTareasURL,
            query: {
              asig_id:  this.$route.query.asig_id,
              curso_id: this.$route.query.curso_id,
            
            },
          })
        ">
        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" class="w-4 h-4 mr-2 stroke-current"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"></path></svg>
        Lista Tareas
      </a>
    </li> 
    <li>
      <a   @click="
          $router.push({
            path: detalleTareaURL,
            query: {
              asig_id:  this.$route.query.asig_id,
              curso_id: this.$route.query.curso_id,
              tarea_id: this.$route.query.tarea_id,
            },
          })
        ">
        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" class="w-4 h-4 mr-2 stroke-current"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"></path></svg>
        Detalles Tarea
      </a>
    </li> 
    <li>
      <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" class="w-4 h-4 mr-2 stroke-current"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 13h6m-3-3v6m5 5H7a2 2 0 01-2-2V5a2 2 0 012-2h5.586a1 1 0 01.707.293l5.414 5.414a1 1 0 01.293.707V19a2 2 0 01-2 2z"></path></svg>
      Subir Entrega
    </li>
  </ul>
</div>
  <h1 class="text-center mt-8 text-3xl font-semibold">
    {{ this.descripcion }}
  </h1>
  <div class="text-center items-align-center">
    <div
      class="bg-accent ml-44 mt-20 rounded-3xl min-w-min h-10 w-3/12 text-center md:text-2xl text-xs font-bold"
    >
      <h1>{{ responseAsig.tipoAsignatura }}</h1>
    </div>
    <div class="bg-white rounded-3xl mr-44 ml-44" style="padding: 30px">
      <p
        class="bg-accent text-center rounded-xl md:text-2xl text-xs font-semibold"
      >
        {{ response.descTarea }}
      </p>
    </div>
    <form class="" id="form" @submit.prevent="registrarTarea()">
      <div class="text-center">
        <div class="text-center">
          <label
            for="descripcion"
            class="block text-sm font-medium text-gray-700 mt-12"
          ></label>

          <textarea
            required
            v-model="entrega.descEntrega"
            class="textarea textarea-bordered w-7/12 mt-1 rounded-md h-24"
            name="descripcionTarea"
            maxlength="300"
            placeholder="Escriba aqui ..."
          ></textarea>
        </div>
      </div>

      <div class="-50 text-center px-4 py-3 sm:px-6">
        <button
          type="reset"
          class="inline-flex mr-5 justify-center rounded-md border border-transparent bg-error py-2 px-4 text-sm font-medium text-white shadow-sm hover:bg-primary focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2"
        >
          Limpiar
        </button>
        <button
          type="submit"
          class="inline-flex justify-center rounded-md border border-transparent bg-accent py-2 px-4 text-sm font-medium text-white shadow-sm hover:bg-primary focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2"
          form="form"
        >
          Guardar Tarea
        </button>
      </div>
      <div class="mt-12">
        <button
          v-if="contador == 0"
          type="button"
          @click="next()"
          class="inline-flex justify-center text-2xl rounded-md border border-transparent bg-success py-2 px-4 font-medium text-white shadow-sm hover:bg-primary focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2"
        >
          Subir Tarea
        </button>

        <button
          v-else
          type="button"
          @click="locationNext()"
          class="inline-flex rounded-md border border-transparent bg-secondary py-2 px-4 text-2xl font-medium text-white shadow-sm hover:bg-primary focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2"
        >
          Continuar...
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import axios from "axios";
import navbar from '../../components/Navbar.vue'
export default {
  components: { navbar },
  name: "SubirTarea",

  data() {
    var today = new Date();
    if (today.getDate() < 10) {
      var date =
        today.getFullYear() +
        "-" +
        (today.getMonth() + 1) +
        "-0" +
        today.getDate();
    } else {
      var date =
        today.getFullYear() +
        "-" +
        (today.getMonth() + 1) +
        "-" +
        today.getDate();
    }

    var time =
      today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();

    return {
      response: [],
      msg: "",
      id: "",
      detalleTareaURL:"",
      listaTareasURL:"",
      elegirAsignaturaURL:"",
      contador: 0,
      descripcion: "",
      fechInicio: "",
      fechTermino: "",
      horaInicio: "",
      horaTermino: "",
      entrega: {
        nombreTareaEntregada: "Tarea",
        fechaEntrega: date,
        horaEntrega: time,
        descEntrega: "",
        estEntrega: "true",
        alumnIdEntrega: this.$route.params.id,
      },
      responseAsig: [],
      asig: [],
      responseEntregable: [],
      responseNext: [],
    };
  },
  mounted() {
    const peticion = this.$route.query.tarea_id;
    const peticionAsig = this.$route.query.asig_id;

    let vue = this;

    const response = axios
      .get("tarea/mostrarTarea", {
        headers: {
          Authorization: localStorage.getItem("auth"),
        },
      })
      .then((response) => {
        vue.response = response.data;

        vue.response.forEach(function (valor, indice, array) {
          if (peticion == response.data[indice].tareaId) {
            vue.response.tareaId = response.data[indice].tareaId;
            vue.response.descTarea = response.data[indice].descTarea;
            vue.response.fechInicio = response.data[
              indice
            ].fechInicio.substring(0, 10);
            vue.response.fechTermino = response.data[
              indice
            ].fechTermino.substring(0, 10);
            vue.response.horaInicio = response.data[indice].horaInicio;
            vue.response.horaTermino = response.data[indice].horaTermino;
          }
        });
      });
    axios
      .get("administracionCursos/cursoAlumno/" +  localStorage.getItem("userId"), {
        headers: {
          Authorization: localStorage.getItem("auth"),
        },
      })
      .then((res) => {
        this.msg = res.data;
        vue.asig = res.data.asignaturas;
        vue.asig.forEach(function (valor, indice, array) {
          console.log(vue.asig);
          if (peticionAsig == res.data.asignaturas[indice].asigId) {
            vue.responseAsig = res.data.asignaturas[indice];
            console.log(res.data.asignaturas);
          }
        });

        console.log(response.data.asignaturas[indice]);

        this.fechaEntrega = this.fecha + this.hora;
      })
      .catch((err) => {
        console.log("index not defined");
      });
      axios
        .get("cuentas/usuario", {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((response) => {
          console.log(response.data.rol);
          if (response.data.rol == "DOCENTE") {
            this.detalleTareaURL =
               "/DetalleTareaDocente";
            this.listaTareasURL=
              "/ListaTareasDocente";
            this.elegirAsignaturaURL=
              "/ElegirAsignatura"
          } else if (response.data.rol == "ALUMNO") {
            this.detalleTareaURL =
            "/DetalleTareaEstudiante";
            this.listaTareasURL=
              "/ListaTareasEstudiante";
            this.elegirAsignaturaURL=
              "/ElegirAsignaturaAlumno"
          }

          console.log(this.peticionTarea);
        });
  },



  methods: {
    registrarTarea() {
      axios
        .post("entregable/registrarEntrega", this.entrega, {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((res) => alert("Se ha agregado la entrega correctamente"))
        .catch((err) => console.log(err));
    },
    next() {
      let vue = this;
      const param = localStorage.getItem("userId");
      const query = this.$route.query.tarea_id;
      console.log(param);
      this.contador = 1 + this.contador;
      axios
        .get("entregable/mostrarEntregable", {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((res) => {
          vue.responseNext = res.data;

          let length = vue.responseNext.length;
          console.log(vue.responseNext);
          console.log(length);

          vue.responseNext.forEach(function (valor, indice, array) {
            console.log(indice);
            if (indice == length - 1) {
              axios
                .put(
                  "entregable/" +
                    param +
                    "/asignarAlumnoEntrega/" +
                    vue.responseNext[indice].entregableId,
                  {
                    headers: {
                      Authorization: localStorage.getItem("auth"),
                    },
                  }
                )
                .then((res) => {})
                .catch((err) => console.log(err));
              axios
                .put(
                  "entregable/" +
                    query +
                    "/asignarEntregableTarea/" +
                    vue.responseNext[indice].entregableId,
                  {
                    headers: {
                      Authorization: localStorage.getItem("auth"),
                    },
                  }
                )
                .then((res) => {})
                .catch((err) => console.log(err));
            }
          });
        })
        .catch((err) => console.log(err));
    },
    locationNext() {
      window.location.replace("ElegirAsignaturaAlumno");
    },
  },
};
</script>

<style></style>
